"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.logRefreshToken = void 0;
/* eslint-disable no-console */
const util_1 = require("./util");
const auth_1 = require("./auth");
function getTokens(email) {
    return __awaiter(this, void 0, void 0, function* () {
        let code = yield util_1.requestInput('Code: ');
        if (code.length === 6) {
            code = code.substr(0, 3) + '-' + code.substr(3);
        }
        try {
            return yield auth_1.getToken(email, code);
        }
        catch (e) {
            console.error('Failed: ', e.response.data.message);
            return getTokens(email);
        }
    });
}
function logRefreshToken() {
    return __awaiter(this, void 0, void 0, function* () {
        console.log('This CLI will provide you with a token which you can use to configure homebridge-petsafe-smart-feed. Please enter your email address to start the process.');
        const email = yield util_1.requestInput('Email: ');
        yield auth_1.requestCode(email);
        console.log('You should now receive an email from PetSafe.  Please enter the code from that email below.');
        const token = yield getTokens(email);
        console.log('\nSuccessfully logged in to PetSafe. Please use the following line in your homebridge config:\n');
        console.log(`"token": "${token}"`);
    });
}
exports.logRefreshToken = logRefreshToken;
// eslint-disable-next-line @typescript-eslint/no-empty-function
process.on('unhandledRejection', () => { });
