"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getToken = exports.requestCode = void 0;
const rest_client_1 = require("./rest-client");
function requestCode(email) {
    return __awaiter(this, void 0, void 0, function* () {
        yield rest_client_1.requestWithRetry({
            method: 'POST',
            url: rest_client_1.userPath(),
            json: {
                consentVersion: '2019-06-25',
                email,
                language: 'en',
            },
        });
    });
}
exports.requestCode = requestCode;
function getToken(email, code) {
    return __awaiter(this, void 0, void 0, function* () {
        const tokens = yield rest_client_1.requestWithRetry({
            method: 'POST',
            url: rest_client_1.userPath('tokens'),
            json: {
                code,
                email,
            },
        });
        return tokens.deprecatedToken;
    });
}
exports.getToken = getToken;
